> ## Documentation Index
> Fetch the complete documentation index at: https://docs.allium.so/llms.txt
> Use this file to discover all available pages before exploring further.

# Get deployment metrics

> Returns throughput, latency, and error rate metrics for a deployed pipeline.

Returns throughput, latency, and error rate metrics for the deployment.

<Note>
  **Required permission:** `read` — owners, editors, readers, and members of teams shared via `viewer_team`.
</Note>

**Path parameters:**

| Parameter   | Description               |
| :---------- | :------------------------ |
| `config_id` | Pipeline configuration ID |

**Query parameters:**

| Parameter    | Default | Description                                                              |
| :----------- | :------ | :----------------------------------------------------------------------- |
| `time_range` | `1h`    | Time range: `1h`, `1d`, or `1w`                                          |
| `aggregated` | `false` | `true` returns a single summary, `false` returns time-series data points |

```bash theme={null}
curl -X GET "https://api.allium.so/api/v1/beam/${CONFIG_ID}/deploy/metrics?time_range=1h&aggregated=true" \
  -H "X-API-Key: ${ALLIUM_API_KEY}"
```

**Available metric types:** `messages_received`, `messages_sent`, `total_latency`, `processing_latency`, `processor_errors`, `output_errors`, `data_freshness`

<Tabs>
  <Tab title="Time-series (default)">
    ```json theme={null}
    {
      "config_id": "abc123",
      "metrics": [
        {
          "metric_type": "messages_received",
          "points": [
            { "timestamp": "2026-03-24T07:21:40Z", "value": 0.0 },
            { "timestamp": "2026-03-24T07:22:40Z", "value": 15.3 },
            { "timestamp": "2026-03-24T07:23:40Z", "value": 22.1 }
          ]
        },
        {
          "metric_type": "messages_sent",
          "points": []
        }
      ]
    }
    ```
  </Tab>

  <Tab title="Aggregated">
    ```json theme={null}
    {
      "pipeline_id": "abc123",
      "time_range": "1h",
      "messages_received_per_min": 411.98,
      "messages_sent_per_min": 411.98,
      "total_latency": {
        "p50": 222.55,
        "p90": 266.46,
        "p99": 266.46,
        "unit": "ms"
      },
      "processing_latency": [
        {
          "path": "path:v8-transform",
          "latency": { "p50": 1.21, "p90": 2.26, "p99": 2.26, "unit": "ms" }
        }
      ],
      "processor_error_rate": 0.0,
      "output_error_rate": 0.0,
      "data_freshness_ms": 2043.49
    }
    ```
  </Tab>
</Tabs>


## OpenAPI

````yaml _openapi/beam-api.json GET /api/v1/beam/{config_id}/deploy/metrics
openapi: 3.1.0
info:
  title: Allium Beam API
  description: Allium Beam — managed streaming pipelines on top of Allium Datastreams.
  version: 1.0.0
servers:
  - url: https://api.allium.so
security: []
paths:
  /api/v1/beam/{config_id}/deploy/metrics:
    get:
      tags:
        - BEAM
      summary: Get Pipeline Metrics Handler
      description: Get metrics for a pipeline.
      operationId: get_pipeline_metrics_handler_api_v1_beam__config_id__deploy_metrics_get
      parameters:
        - name: config_id
          in: path
          required: true
          schema:
            type: string
            title: Config Id
        - name: time_range
          in: query
          required: false
          schema:
            $ref: '#/components/schemas/MetricTimeRange'
            description: Time range for metrics
            default: 1h
          description: Time range for metrics
        - name: aggregated
          in: query
          required: false
          schema:
            type: boolean
            description: >-
              If True, returns aggregated pipeline metrics. If False, returns
              raw metric series.
            default: false
            title: Aggregated
          description: >-
            If True, returns aggregated pipeline metrics. If False, returns raw
            metric series.
      responses:
        '200':
          description: Successful Response
          content:
            application/json:
              schema:
                anyOf:
                  - $ref: '#/components/schemas/PipelineMetricsResponse'
                  - $ref: '#/components/schemas/RawMetricsResponse'
                title: >-
                  Response Get Pipeline Metrics Handler Api V1 Beam  Config Id 
                  Deploy Metrics Get
        '422':
          description: Validation Error
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/HTTPValidationError'
      security:
        - APIKeyBearer: []
components:
  schemas:
    MetricTimeRange:
      type: string
      enum:
        - 1h
        - 1d
        - 1w
      title: MetricTimeRange
    PipelineMetricsResponse:
      properties:
        pipeline_id:
          type: string
          title: Pipeline Id
        time_range:
          type: string
          title: Time Range
        messages_received_per_min:
          anyOf:
            - type: number
            - type: 'null'
          title: Messages Received Per Min
        messages_sent_per_min:
          anyOf:
            - type: number
            - type: 'null'
          title: Messages Sent Per Min
        total_latency:
          $ref: '#/components/schemas/LatencyPercentiles'
        processing_latency:
          items:
            $ref: '#/components/schemas/ProcessorLatency'
          type: array
          title: Processing Latency
        processor_error_rate:
          anyOf:
            - type: number
            - type: 'null'
          title: Processor Error Rate
        output_error_rate:
          anyOf:
            - type: number
            - type: 'null'
          title: Output Error Rate
        data_freshness_ms:
          anyOf:
            - type: number
            - type: 'null'
          title: Data Freshness Ms
      type: object
      required:
        - pipeline_id
        - time_range
      title: PipelineMetricsResponse
    RawMetricsResponse:
      properties:
        config_id:
          type: string
          title: Config Id
        metrics:
          items:
            $ref: '#/components/schemas/MetricSeriesItem'
          type: array
          title: Metrics
      type: object
      required:
        - config_id
        - metrics
      title: RawMetricsResponse
    HTTPValidationError:
      properties:
        detail:
          items:
            $ref: '#/components/schemas/ValidationError'
          type: array
          title: Detail
      type: object
      title: HTTPValidationError
    LatencyPercentiles:
      properties:
        p50:
          anyOf:
            - type: number
            - type: 'null'
          title: P50
        p90:
          anyOf:
            - type: number
            - type: 'null'
          title: P90
        p99:
          anyOf:
            - type: number
            - type: 'null'
          title: P99
        unit:
          type: string
          title: Unit
          default: ms
      type: object
      title: LatencyPercentiles
    ProcessorLatency:
      properties:
        path:
          type: string
          title: Path
        latency:
          $ref: '#/components/schemas/LatencyPercentiles'
      type: object
      required:
        - path
      title: ProcessorLatency
    MetricSeriesItem:
      properties:
        metric_type:
          type: string
          title: Metric Type
        points:
          items:
            $ref: '#/components/schemas/MetricPoint'
          type: array
          title: Points
        tag_set:
          items:
            type: string
          type: array
          uniqueItems: true
          title: Tag Set
      type: object
      required:
        - metric_type
        - points
      title: MetricSeriesItem
    ValidationError:
      properties:
        loc:
          items:
            anyOf:
              - type: string
              - type: integer
          type: array
          title: Location
        msg:
          type: string
          title: Message
        type:
          type: string
          title: Error Type
      type: object
      required:
        - loc
        - msg
        - type
      title: ValidationError
    MetricPoint:
      properties:
        timestamp:
          type: string
          format: date-time
          title: Timestamp
        value:
          type: number
          title: Value
      type: object
      required:
        - timestamp
        - value
      title: MetricPoint
  securitySchemes:
    APIKeyBearer:
      type: apiKey
      in: header
      name: X-API-KEY

````